using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Text;

using Steema.TeeChart.Web;
using Steema.TeeChart.Styles;


namespace WebDemo.Interacting_with_Charts.Zooming
{
    /// <summary>
    /// Summary description for WebForm1.
    /// </summary>
    public partial class WebAppZoomChartLine : System.Web.UI.Page
    {
        private int clickedX;
        private int clickedY;
        private string msgText;

        protected void Page_Load(object sender, System.EventArgs e)
        {

            WebChart1.AutoPostback = true;//Add AutoPostback.
            WebChart1.Chart.Chart.Aspect.View3D = false;
            if (!IsPostBack)
            {
                if (Session["MyIe9Mode"] == null)
                    Session["MyIe9Mode"] = CheckBoxie9mode.Checked;
                else
                    CheckBoxie9mode.Checked = (bool)Session["MyIe9Mode"];
            }

            if (CheckBoxie9mode.Checked)
                HttpContext.Current.Response.AddHeader("X-UA-Compatible", "IE=9");


            clickedX = -1;
            clickedY = -1;
            msgText = "";
            // Put user code to initialize the page here
            // ****************************************************
            // The data load code for WebChart1 demostrates a technique to save 
            // data between page calls. The Chart is saved as a TeeChart template 
            // to a session variable.
            // ****************************************************
            Steema.TeeChart.Chart ch1 = WebChart1.Chart;
            MemoryStream tmpChart = new MemoryStream();

            if (Session["ch1"] == null)
            {
                //setup Chart
                if (ch1.Series.Count < 2)
                {
                    ch1.Series.Add(new Steema.TeeChart.Styles.Line());
                    ch1.Series.Add(new Steema.TeeChart.Styles.Line());
                }


                if (ch1.Tools.Count < 1)
                {
                    ch1.Tools.Add(new Steema.TeeChart.Tools.ZoomTool());
                    ch1.Tools.Add(new Steema.TeeChart.Tools.SeriesHotspot());
                }

                ((Steema.TeeChart.Tools.ZoomTool)ch1.Tools[0]).ZoomPenColor = Color.OliveDrab;
                ((Steema.TeeChart.Tools.SeriesHotspot)ch1.Tools[1]).Style = MarksStyles.LabelPercentTotal;


                

                DropDownListTransparenzProzent.SelectedValue = "70";

                ch1.Series[0].FillSampleValues(50);
                ch1.Series[1].FillSampleValues(50);

                ch1.Series[0].Color = Color.Blue;
                ch1.Series[1].Color = Color.Red;
                ((Line)ch1.Series[0]).Color = Color.Blue;
                ((Line)ch1.Series[1]).Color = Color.Red;
                ((Line)ch1.Series[0]).LinePen.Color = Color.DarkBlue;
                ((Line)ch1.Series[1]).LinePen.Color = Color.DarkRed;


                do3D_and_Transparency();
                //export Chart to a MemoryStream template
                ch1.Export.Template.Save(tmpChart);
                //save template to a Session variable
                Session.Add("ch1", tmpChart);
            }
            else
            {
                //retrieve the session stored Chart
                tmpChart = (MemoryStream)Session["ch1"];
                //set the Stream position to 0 as the last read/write
                //will have moved the position to the end of the stream
                tmpChart.Position = 0;
                //import saved Chart
                WebChart1.Chart.Import.Template.Load(tmpChart);
                WebChart1.Chart.Chart.Aspect.View3D = false;

                do3D_and_Transparency();
                //check whether zoom request is being sent
                CheckZoom(WebChart1);
            }
        }
        private void do3D_and_Transparency()
        {
            WebChart1.Chart.Chart.Aspect.View3D = CheckBox3D.Checked;

            //WebChart1.Chart.Graphics3D.BufferStyle = Steema.TeeChart.Drawing.BufferStyle.None; 

            WebChart1.Chart.Chart.Walls.Right.Transparent = true;

            for (int i = 0; i < WebChart1.Chart.Series.Count; i++)
            {
                if (i == 0)
                {
                    ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Style = PointerStyles.Rectangle;//.Circle;//.Rectangle;
                }
                else
                {
                    ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Style = PointerStyles.Circle;//.Rectangle;
                }

                if (i == 0)
                {
                    ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Color = Color.Blue;
                }
                else
                {
                    ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Color = Color.Red;
                }


                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Brush.Invalidate();


                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Draw3D = WebChart1.Chart.Chart.Aspect.View3D;
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Dark3D = (DropDownListTransparenzProzent.SelectedValue == "0");

                //((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).OutLine.Transparency = 100;
                //((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).OutLine.Width = 0;

                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).OutLine.Visible = false;
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).LinePen.Width = 1;
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).LinePen.Visible = 
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Visible =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Pen.Visible = true;
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Brush.Visible = true;

                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.HorizSize =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.VertSize = 4;

                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Depth = 10;

                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Stacked = CustomStack.None;
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Stairs = false;



                //((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).OutLine.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).LinePen.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Brush.Transparency =
                //((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Marks.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Pen.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Pointer.Brush.Transparency =
                ((Steema.TeeChart.Styles.Line)WebChart1.Chart[i]).Transparency = Convert.ToInt32(DropDownListTransparenzProzent.SelectedValue.ToString());

                //WebChart1.Chart[i].Invalidate();
                //WebChart1.Chart[i].RefreshSeries();

            }
            //WebChart1.Chart.Chart.Aspect.Invalidate();
        }

        private void CheckZoom(WebChart wChart)
        {
            ArrayList zoomedState = (ArrayList)Session[wChart.ID + "Zoomed"];
            zoomedState = ((Steema.TeeChart.Tools.ZoomTool)wChart.Chart.Tools[0]).SetCurrentZoom(Request,
                zoomedState);
            if (zoomedState == null)
                Session.Remove(wChart.ID + "Zoomed");
            else
                Session.Add(wChart.ID + "Zoomed", zoomedState);
        }

        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);

        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {

        }
        #endregion

        protected void WebChart1_ClickAxis(object sender, ImageClickEventArgs e)
        {
            Steema.TeeChart.Axis axis = (Steema.TeeChart.Axis)sender;
            clickedX = e.X;
            clickedY = e.Y;
            double axisValue = 0;
            if (axis.Horizontal)
                axisValue = ((Steema.TeeChart.Axis)sender).CalcPosPoint(clickedX);
            else
                axisValue = ((Steema.TeeChart.Axis)sender).CalcPosPoint(clickedY);
            msgText = "Clicked Axis at:" + "\n\rValue: " + axisValue.ToString("#.00");
        }
        protected void WebChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            if (clickedX != -1)
            {
                g.Font.Color = Color.Maroon;
                g.TextOut(clickedX, clickedY, msgText);
            }
        }
        protected void WebChart1_ClickSeries(object sender, Series s, int valueIndex, EventArgs e)
        {
            Steema.TeeChart.Chart tChart = ((WebChart)sender).Chart;

            clickedX = s.CalcXPos(valueIndex);
            clickedY = s.CalcYPos(valueIndex);
            msgText = "Clicked Series: " + tChart.Series.IndexOf(s).ToString() + "\n\rValue: " + s.YValues[valueIndex].ToString("#0.00");
        }
        protected void Button1_Click(object sender, EventArgs e)
        {

        }
        protected void Button2_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/scrolltool.aspx");
        }
        protected void CheckBox3D_CheckedChanged(object sender, EventArgs e)
        {
            
        }
        protected void DropDownListTransparenzProzent_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }
        protected void CheckBoxie9mode_CheckedChanged(object sender, EventArgs e)
        {
            Session["MyIe9Mode"] = CheckBoxie9mode.Checked;
            Response.Redirect(Request.AppRelativeCurrentExecutionFilePath);
        }
    }
}
